﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Serpineski
{
    public partial class Form1 : Form
    {
        int last = 10, sl = 10, r = 220, ratio = 2, rate = 2;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            Pen s = new Pen(Color.Yellow);
            Graphics saber = this.CreateGraphics();
            saber.DrawLine(s, 400, 400, 400 + r / ratio, 400 - (float)(3 / Math.Sqrt(3)) * (r / ratio));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, 400 + (r / ratio), 400 - (float)(3 / Math.Sqrt(3)) * (r / ratio), 400 - (r / ratio), 400 - (float)(3 / Math.Sqrt(3)) * (r / ratio));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, 400 - (r / ratio), 400 - (float)(3 / Math.Sqrt(3)) * (r / ratio), 400, 400);
            System.Threading.Thread.Sleep(sl);
            Point ri = new Point(Convert.ToInt32((400 + 400 + (r / ratio)) / ratio), Convert.ToInt32((400 + (400 - (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
            right(ri, r);
            Point upp = new Point(Convert.ToInt32((400 + (r / ratio) + 400 - (r / ratio)) / ratio), Convert.ToInt32(400 - (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            up(upp, r);
            Point le = new Point(Convert.ToInt32((400 - (r / ratio) + 400) / ratio), Convert.ToInt32((400 + (400 - (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
            left(le, r);
        }

        void right(Point p, double r)
        {
            r = r / rate;
            Pen s = new Pen(Color.Yellow);
            Graphics saber = this.CreateGraphics();
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X+r), p.Y);
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X + r / ratio), Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, Convert.ToInt32(p.X + r), p.Y, Convert.ToInt32(p.X + r / ratio), Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            if (r > last)
            {
                Point ri = new Point(Convert.ToInt32((Convert.ToInt32(p.X + r) + Convert.ToInt32(p.X + r / ratio)) / ratio), Convert.ToInt32((p.Y + Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
                right(ri,r);
                Point upp = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X + r)) / ratio), p.Y);
                up(upp, r);
                Point le = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X + r / ratio)) / ratio), Convert.ToInt32((p.Y + Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
                left(le, r);
            }
        }

        void up(Point p, double r)
        {
            r = r / rate;
            Pen s = new Pen(Color.Yellow);
            Graphics saber = this.CreateGraphics();
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X - r / ratio), Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X + r / ratio), Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, Convert.ToInt32(p.X + r / ratio), Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)), Convert.ToInt32(p.X - r / ratio), Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            if (r > last)
            {
                Point ri = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X + r / ratio)) / ratio), Convert.ToInt32((p.Y + (Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)))) / ratio));
                right(ri, r);
                Point upp = new Point(p.X, Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio)));
                up(upp, r);
                Point le = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X - r / ratio)) / ratio), Convert.ToInt32((p.Y + Convert.ToInt32(p.Y - (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
                left(le, r);
            }
        }

        void left(Point p, double r)
        {
            r = r / ratio;
            Pen s = new Pen(Color.Yellow);
            Graphics saber = this.CreateGraphics();
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X - r), p.Y);
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, p.X, p.Y, Convert.ToInt32(p.X - r / ratio), Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            saber.DrawLine(s, Convert.ToInt32(p.X - r), p.Y, Convert.ToInt32(p.X - r / ratio), Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio)));
            System.Threading.Thread.Sleep(sl);
            if (r > last)
            {
                Point ri = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X - r / ratio)) / ratio), Convert.ToInt32((p.Y + Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
                right(ri, r);
                Point upp = new Point(Convert.ToInt32((p.X + Convert.ToInt32(p.X - r)) / ratio), p.Y);
                up(upp, r);
                Point le = new Point(Convert.ToInt32((Convert.ToInt32(p.X - r) + Convert.ToInt32(p.X - r / ratio)) / ratio), Convert.ToInt32((p.Y + Convert.ToInt32(p.Y + (float)(3 / Math.Sqrt(3)) * (r / ratio))) / ratio));
                left(le, r);
            }
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            backgroundWorker2.RunWorkerAsync();
        }

        private void backgroundWorker2_DoWork(object sender, DoWorkEventArgs e)
        {
            string saberm = "Saber MalekzadeH\n\nAlgorithm Disigning\n\nDr.Razavi\n\nSirpineski Triangle\n\nWith\n\nBack Track Way\n\n896325605";
            for (int i = 0; i < saberm.Length; i++)
            {
                this.Invoke(new Action(() =>
                {
                    label1.Text += saberm[i];
                }));
                System.Threading.Thread.Sleep(100);
            }
            saberm = "Much Thanks For All For\n\nDr.Razavi";
            for (int i = 0; i < saberm.Length; i++)
            {
                this.Invoke(new Action(() =>
                {
                    label2.Text += saberm[i];
                }));
                System.Threading.Thread.Sleep(100);
            }
        }
    }
}
